From c92b857adb5d94a531e4a9ac6942f3a91ab4bea0 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jul 31 2015 16:17:39 +0000
Subject: [PATCH 196/1001] Start a cobwebs widget.


---

diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index b644707..06a3b79 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -9,6 +9,7 @@ from hubs.widgets import fedmsgs
 from hubs.widgets import fedmsgstats
 from hubs.widgets import feed
 from hubs.widgets import subscriptions
+from hubs.widgets import cobwebs
 
 from hubs.widgets.workflow import pendingacls
 from hubs.widgets.workflow import updates2stable
@@ -27,6 +28,7 @@ registry = {
     'fedmsgstats': fedmsgstats,
     'feed': feed,
     'subscriptions': subscriptions,
+    'cobwebs': cobwebs,
 
     'workflow.pendingacls': pendingacls,
     'workflow.updates2stable': updates2stable,
diff --git a/hubs/widgets/cobwebs.py b/hubs/widgets/cobwebs.py
new file mode 100644
index 0000000..d6684b2
--- /dev/null
+++ b/hubs/widgets/cobwebs.py
@@ -0,0 +1,36 @@
+from hubs.hinting import hint, prefixed as _
+
+import arrow
+import datetime
+import jinja2
+
+from hubs.widgets.chrome import panel
+chrome = panel(None, key='old', klass='panel-info')
+
+template = jinja2.Template("""
+{% if old %}
+<ul class="media-list">
+    <li class="media">
+        <div class="media-left">
+            <img class="media-object square-32" src="http://placekitten.com/g/32/32"/>
+        </div>
+        <div class="media-body">
+            Cobweb alert!  This hub was last active {{then}}.
+        </div>
+    </li>
+</ul>
+{% endif %}
+""")
+
+
+def data(session, widget):
+    days = widget.hub.days_idle
+    old = days > 31
+    then = datetime.datetime.utcnow() - datetime.timedelta(days=days)
+    then = arrow.get(then).humanize()
+    return dict(old=old, days=days, then=then)
+
+
+#@hint(topics=[_('hubs.widget.update')])
+def should_invalidate(message, session, widget):
+    raise NotImplementedError()
diff --git a/populate.py b/populate.py
index d682889..5b4f7a2 100755
--- a/populate.py
+++ b/populate.py
@@ -44,12 +44,14 @@ widget = hubs.models.Widget(plugin='about', index=3,
                             }))
 hub.widgets.append(widget)
 
-widget = hubs.models.Widget(plugin='sticky', index=0, left=True,
+widget = hubs.models.Widget(plugin='cobwebs', index=0, left=True)
+hub.widgets.append(widget)
+widget = hubs.models.Widget(plugin='sticky', index=1, left=True,
                             _config=json.dumps({
                                 'text': "<p>The Fedora I18N project works on internationalization (i18n) to support the localization (l10n) of Fedora in many languages. Translation of Fedora software and documentation are handled by the Fedora L10N project.</p> <p>The goals of the Project are to:</p> <ul><li>Develop, package, and maintain applications like input methods for different languages</li> <li>Improve applications and utilities to support and process different languages</li> <li>Quality-assure that existing applications meet i18n standards</li> <li>Support the infrastructure of the Fedora Localization Project</li></ul>",
                             }))
 hub.widgets.append(widget)
-widget = hubs.models.Widget(plugin='dummy', index=1, left=True)
+widget = hubs.models.Widget(plugin='dummy', index=2, left=True)
 hub.widgets.append(widget)
 
 
@@ -83,12 +85,14 @@ widget = hubs.models.Widget(plugin='about', index=3,
                             }))
 hub.widgets.append(widget)
 
-widget = hubs.models.Widget(plugin='sticky', index=0, left=True,
+widget = hubs.models.Widget(plugin='cobwebs', index=0, left=True)
+hub.widgets.append(widget)
+widget = hubs.models.Widget(plugin='sticky', index=1, left=True,
                             _config=json.dumps({
                                 'text': "The Fedora Marketing Team develops and executes marketing strategies to promote the usage and support of Fedora worldwide. Through the development of processes and content, this project aims to support the efforts of other Fedora projects to spread Fedora and to provide a central repository of ideas and information that can be used to deliver Fedora to new audiences. We work closely with the Fedora Ambassadors who spread the word about Fedora at events and allow the Fedora Project to interact directly with its existing and prospective users. ",
                             }))
 hub.widgets.append(widget)
-widget = hubs.models.Widget(plugin='dummy', index=1, left=True)
+widget = hubs.models.Widget(plugin='dummy', index=2, left=True)
 hub.widgets.append(widget)
 
 
@@ -125,12 +129,14 @@ widget = hubs.models.Widget(plugin='about', index=3,
                             }))
 hub.widgets.append(widget)
 
-widget = hubs.models.Widget(plugin='sticky', index=0, left=True,
+widget = hubs.models.Widget(plugin='cobwebs', index=0, left=True)
+hub.widgets.append(widget)
+widget = hubs.models.Widget(plugin='sticky', index=1, left=True,
                             _config=json.dumps({
                                 'text': "The Design Team is the design group of the Fedora project. Our interests are not only in creating graphics for use by the Fedora community, but also in advocating the use of the creative tools that are a part of Fedora.",
                             }))
 hub.widgets.append(widget)
-widget = hubs.models.Widget(plugin='dummy', index=1, left=True)
+widget = hubs.models.Widget(plugin='dummy', index=2, left=True)
 hub.widgets.append(widget)
 
 
@@ -168,12 +174,14 @@ widget = hubs.models.Widget(plugin='about', index=3,
                             }))
 hub.widgets.append(widget)
 
-widget = hubs.models.Widget(plugin='sticky', index=0, left=True,
+widget = hubs.models.Widget(plugin='cobwebs', index=0, left=True)
+hub.widgets.append(widget)
+widget = hubs.models.Widget(plugin='sticky', index=2, left=True,
                             _config=json.dumps({
                                 'text': "The Infrastructure Team consists of dedicated volunteers and professionals managing the servers, building the tools and utilities, and creating new applications to make Fedora development a smoother process. We're located all over the globe and communicate primarily by IRC and e-mail. ",
                             }))
 hub.widgets.append(widget)
-widget = hubs.models.Widget(plugin='dummy', index=1, left=True)
+widget = hubs.models.Widget(plugin='dummy', index=3, left=True)
 hub.widgets.append(widget)
 
 

